package org.classpath.icedtea.pulseaudio;

import static org.junit.Assert.assertNotNull;

import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;

import junit.framework.JUnit4TestAdapter;

import org.junit.After;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

public class PulseAudioEventLoopOverhead {

	public static junit.framework.Test suite() {
		return new JUnit4TestAdapter(PulseAudioEventLoopOverhead.class);
	}

	Mixer selectedMixer;

	@Before
	public void setUp() {
		Mixer.Info mixerInfos[] = AudioSystem.getMixerInfo();
		Mixer.Info selectedMixerInfo = null;
		// int i = 0;
		for (Mixer.Info info : mixerInfos) {
			// System.out.println("Mixer Line " + i++ + ": " + info.getName() +
			// " " + info.getDescription());
			if (info.getName().contains("PulseAudio")) {
				selectedMixerInfo = info;
			}
		}
		assertNotNull(selectedMixerInfo);
		selectedMixer = (PulseAudioMixer) AudioSystem
				.getMixer(selectedMixerInfo);
		assertNotNull(selectedMixer);
		if (selectedMixer.isOpen()) {
			selectedMixer.close();
		}

	}

	@Test @Ignore
	public void testLongWait() throws LineUnavailableException {
		selectedMixer.open();
		try {
			/*
			 * While this test is running, the java procces shouldnt be hogging
			 * the cpu at all
			 */

			Thread.sleep(100000);
		} catch (InterruptedException e) {
			System.out.println("thread interrupted");
		}

	}

	@After
	public void tearDown() {

	}

}
